 # -*- coding: utf-8 -*-
"""
Created on Thu Mar 29 17:09:31 2018

@author: tladd
"""

import json
import imageio
import numpy as np
import matplotlib.pyplot as plt
from scipy.spatial import ConvexHull

time1 = [0, 1, 2, 3, 4, 5, 6]
time2 = ['00001400', '00660600', '01312600', '01680100', '01975400', '02179800', '02333800']
areas = [1.0, 0.75, 0.5184, 0.3032, 0.1547, 0.0695, 0.0204]
scale = 310
shift = [550,498]
dshft = np.array([0, 15, 30, 52, 78, 103, 125])

plt.rcParams['mathtext.fontset'] = 'stix'
plt.rcParams['font.family'] = 'STIXGeneral'
plt.rcParams['font.size'] = 16
plt.close('all')
with open('points.json', 'r') as pointsFile:
    allPoints = json.load(pointsFile)

#time1 = [0]
for index in range(len(time1)):
    hull   = ConvexHull(np.array(allPoints[time1[index]], float))  # Get points from hull
    edges  = (hull.points[hull.simplices])*scale + shift - [dshft[index],0]
    img=imageio.imread(time2[index] +'.jpg')
    points = allPoints[index]
    a  = 0
    cx = 0
    for v1 in range(len(points)):
        v2 = (v1+1)%len(points)
        x   = (points[v2][0]+points[v1][0])/2
        dy  =  points[v2][1]-points[v1][1]
        a  += x*dy
        cx += 0.5*x*x*dy
    print('area at time ', time1[index], ' = ', a/(np.pi))
    print('center of mass = ', cx/a)
    
       
#plots
    plt.close()
    plt.figure(1, figsize=(6,6))
    plt.axis('off')
    plt.imshow(img, cmap=plt.cm.gray)
    for edge in edges:
        plt.plot(edge[:,0], edge[:,1], color='red', linestyle='solid', linewidth= 2) # plot hull1 
    
    plt.savefig('shape_' + str(time1[index]) + '.png')
    plt.show()
