# -*- coding: utf-8 -*-
"""
Created on Thu Mar 29 17:09:31 2018

@author: tladd
"""

import math
import numpy as np
import matplotlib.pyplot as plt
import scipy.special as spe
import pickle

plt.rcParams['mathtext.fontset'] = 'stix'
plt.rcParams['font.family'] = 'STIXGeneral'
plt.rcParams['font.size'] = 16
plt.rcParams['legend.fontsize'] = 14
plt.rcParams['xtick.labelsize'] = 14
plt.rcParams['ytick.labelsize'] = 14

Pe   = 250
M    = 128
name  = 'Pe='+str(Pe)+'-M='+str(M)+'-High'
t, y = pickle.load(open('../data/'+name+'.pickle', 'rb'))
t0   = math.sqrt(Pe*math.pi**3/36)

plt.clf()
plt.plot(t/t0, y.T[-1], color='black', linestyle='solid', label='$a_1$')
plt.plot(t/t0, y.T[-2], color='red', linestyle='solid', label='$a_0$')
plt.plot(t/t0, y.T[-3], color='blue', linestyle='solid', label='$a_{-1}$')
plt.plot(t/t0, y.T[-4], color='magenta', linestyle='solid', label='$a_{-2}$')

t = np.linspace(0,1,1001)
a1 = (1-t)**(2/3)
a0 = 5*(spe.expi(7.5) - spe.expi(7.5+np.log(a1))) / math.exp(7.5)
am = -a1*np.log(a1)*2/15
plt.plot(t, a1, color='black', linestyle='dashed')
plt.plot(t, a0, color='red', linestyle='dashed')
plt.plot(t, am, color='blue', linestyle='dashed')

plt.xlim(0,1)
plt.ylim(0,1)
plt.xlabel(r'$t/t_0^0$', labelpad=-1)
plt.ylabel(r'$a_m(t)$')
plt.legend(loc='best')  
plt.show()
plt.savefig('../fig7.pdf')
